// SLLogToDebug.h : Declaration of the CSLLogToDebug

#pragma once
#include "resource.h"       // main symbols

#include "SLLogToDebugDll_i.h"




// CSLLogToDebug

class ATL_NO_VTABLE CSLLogToDebug :
  public CComObjectRootEx<CComMultiThreadModel>,
  public CComCoClass<CSLLogToDebug, &CLSID_SLLogToDebug>,
  public IDispatchImpl<ISLLogListener, &IID_ISLLogListener, &LIBID_SLLogToDebugDllLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
  public IDispatchImpl<IRefreshSettings, &__uuidof(IRefreshSettings), &LIBID_SLLogToDebugDllLib, /* wMajor = */ 1, /* wMinor = */ 0>
{
public:
  CSLLogToDebug()
  {
  }

  DECLARE_REGISTRY_RESOURCEID(IDR_SLLOGTODEBUG)

  DECLARE_NOT_AGGREGATABLE(CSLLogToDebug)

  BEGIN_COM_MAP(CSLLogToDebug)
    COM_INTERFACE_ENTRY(ISLLogListener)
    COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY(IRefreshSettings)
  END_COM_MAP()



  DECLARE_PROTECT_FINAL_CONSTRUCT()

  HRESULT FinalConstruct()
  {
    return S_OK;
  }

  void FinalRelease()
  {
  }

public:
  STDMETHOD(Log)(LONGLONG UtcTime, BSTR Owner, BSTR Source, BSTR Type, BSTR Message)
  {
    SYSTEMTIME t;
    FILETIME f;
    FileTimeToLocalFileTime((FILETIME*)(void*)&UtcTime,&f);
    FileTimeToSystemTime(&f,&t);
    CStringW ret;
    ret.Format(L"%04d-%02d-%02d %02d:%02d:%02d.%03d %s %s %s %s",t.wYear,t.wMonth,t.wDay,t.wHour,t.wMinute,t.wSecond,t.wMilliseconds,
      Owner,Source,Type,Message);
    OutputDebugString(ret);
    return S_OK;
  }

  // IRefreshSettings Methods
public:
  STDMETHOD(ReloadSettings)()
  {
    OutputDebugString(L"ReloadSettings");
    return S_OK;
  }
};

OBJECT_ENTRY_AUTO(__uuidof(SLLogToDebug), CSLLogToDebug)
