// SLLogToDebugDll.cpp : Implementation of DLL Exports.


#include "stdafx.h"
#include "resource.h"
#include "SLLogToDebugDll_i.h"
#include "dllmain.h"

// Used to determine whether the DLL can be unloaded by OLE
STDAPI DllCanUnloadNow(void)
{
    return _AtlModule.DllCanUnloadNow();
}


// Returns a class factory to create an object of the requested type
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}


// DllRegisterServer - Adds entries to the system registry
STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    HRESULT hr = _AtlModule.DllRegisterServer();
  
  CComPtr<ICatRegister> pICatRegister;
  HRESULT hhr = pICatRegister.CoCreateInstance(CLSID_StdComponentCategoriesMgr);
  if (hhr==S_OK) {
    CATEGORYINFO cat;
    cat.catid=CLSID_SLLogListener;
    cat.lcid=0x409;
    wcscpy_s(cat.szDescription,L"SLLogListener category");
    pICatRegister->RegisterCategories(1,&cat);
    pICatRegister->RegisterClassImplCategories(CLSID_SLLogToDebug,1,&(cat.catid));
  }
	return hr;
}


// DllUnregisterServer - Removes entries from the system registry
STDAPI DllUnregisterServer(void)
{
	HRESULT hr = _AtlModule.DllUnregisterServer();
	return hr;
}

// DllInstall - Adds/Removes entries to the system registry per user
//              per machine.	
STDAPI DllInstall(BOOL bInstall, LPCWSTR pszCmdLine)
{
    HRESULT hr = E_FAIL;
    static const wchar_t szUserSwitch[] = _T("user");

    if (pszCmdLine != NULL)
    {
    	if (_wcsnicmp(pszCmdLine, szUserSwitch, _countof(szUserSwitch)) == 0)
    	{
    		AtlSetPerUserRegistration(true);
    	}
    }

    if (bInstall)
    {	
    	hr = DllRegisterServer();
    	if (FAILED(hr))
    	{	
    		DllUnregisterServer();
    	}
    }
    else
    {
    	hr = DllUnregisterServer();
    }

    return hr;
}


